Crypto++ 8.9 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
RabinFunction Class Reference

Rabin trapdoor function using the public key. More...

Inheritance diagram for RabinFunction:

## Public Member Functions
void | Initialize (const Integer &n, const Integer &r, const Integer &s)
| Initialize a Rabin public key. More...
void | BERDecode (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
Integer | ApplyFunction (const Integer &x) const
| Applies the trapdoor. More...
Integer | PreimageBound () const
| Returns the maximum size of a message before the trapdoor function is applied. More...
Integer | ImageBound () const
| Returns the maximum size of a representation after the trapdoor function is applied. More...
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
const Integer & | GetModulus () const
const Integer & | GetQuadraticResidueModPrime1 () const
const Integer & | GetQuadraticResidueModPrime2 () const
void | SetModulus (const Integer &n)
void | SetQuadraticResidueModPrime1 (const Integer &r)
void | SetQuadraticResidueModPrime2 (const Integer &s)
Public Member Functions inherited from TrapdoorFunction
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
| Applies the trapdoor function. More...
bool | IsRandomized () const
| Determines if the encryption algorithm is randomized. More...
Public Member Functions inherited from TrapdoorFunctionBounds
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key. More...
virtual Integer | MaxImage () const
| Returns the maximum size of a representation after the trapdoor function is applied bound to a public key. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
virtual void | Save (BufferedTransformation &bt) const
| Saves a key to a BufferedTransformation. More...
virtual void | Load (BufferedTransformation &bt)
| Loads a key from a BufferedTransformation. More...
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
virtual void | Precompute (unsigned int precomputationStorage)
| Perform precomputation. More...
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Additional Inherited Members
Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

Rabin trapdoor function using the public key.

Since
  Crypto++ 2.0

Definition at line 18 of file rabin.h.

## Member Function Documentation

## ◆ Initialize()

void RabinFunction::Initialize | ( | const Integer & | n,
|  | const Integer & | r,
|  | const Integer & | s
| ) |  |
| inline

Initialize a Rabin public key.

Parameters

  n | the modulus
  r | element r
  s | element s

Definition at line 28 of file rabin.h.

## ◆ ApplyFunction()

Integer RabinFunction::ApplyFunction | ( | const Integer & | x | ) | const
| virtual

Applies the trapdoor.

Parameters

  x | the message on which the encryption function is applied

Returns
  the message x encrypted under the public key

ApplyFunction is a generalization of encryption under a public key cryptosystem. Derived classes must implement it.

Implements TrapdoorFunction.

Definition at line 32 of file rabin.cpp.

## ◆ PreimageBound()

Integer RabinFunction::PreimageBound | ( |  | ) | const
| inline virtual

Returns the maximum size of a message before the trapdoor function is applied.

Returns
  the maximum size of a message before the trapdoor function is applied

Derived classes must implement PreimageBound().

Implements TrapdoorFunctionBounds.

Definition at line 35 of file rabin.h.

## ◆ ImageBound()

Integer RabinFunction::ImageBound | ( |  | ) | const
| inline virtual

Returns the maximum size of a representation after the trapdoor function is applied.

Returns
  the maximum size of a representation after the trapdoor function is applied

Derived classes must implement ImageBound().

Implements TrapdoorFunctionBounds.

Definition at line 36 of file rabin.h.

## ◆ Validate()

bool RabinFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const
| virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Implements CryptoMaterial.

Reimplemented in InvertibleRabinFunction.

Definition at line 44 of file rabin.cpp.

## ◆ GetVoidValue()

bool RabinFunction::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const
| virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

Reimplemented in InvertibleRabinFunction.

Definition at line 61 of file rabin.cpp.

## ◆ AssignFrom()

void RabinFunction::AssignFrom | ( | const NameValuePairs & | source | ) |
| virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Reimplemented in InvertibleRabinFunction.

Definition at line 70 of file rabin.cpp.

The documentation for this class was generated from the following files:

- rabin.h
- rabin.cpp